/*
 * Delay line
 */

#ifndef __DELAY_LINE_H__
#define __DELAY_LINE_H__

#include <glib.h>

typedef struct st_delay_line
{
  gdouble *line;
  gint idx;
  gint size;
  gdouble dsize;
  gdouble duration;

} DelayLine ;


/*
 * Constructor
 */
DelayLine *
delay_line_new ( gdouble,
                 const guint );


/*
 * Cloning operation
 */
DelayLine *
delay_line_clone ( DelayLine * );


/*
 * Getting the size of the delay line
 */
gint
delay_line_get_size ( DelayLine * );


/*
 * Feeding a delay line
 */
void
delay_line_feed ( DelayLine *,
                  gdouble );


/*
 * Reading a value in a delay line
 */
gdouble
delay_line_read ( DelayLine *,
                  gdouble );


/*
 * Reading the oldest value in a delay line
 */
gdouble
delay_line_read_oldest ( DelayLine * );


/*
 * Reset the delay line
 */
void
delay_line_reset ( DelayLine * );


/*
 * Destructor
 */
void
delay_line_destroy ( DelayLine * );

#endif
