/*
 * Effect
 */

#ifndef __EFFECT_H__
#define __EFFECT_H__

#include <gtk/gtk.h>

typedef void EffectInit ( gpointer );
typedef gpointer EffectClone ( gpointer );
typedef void EffectMakeUI ( gpointer, GtkBox * );
typedef void EffectShowUI ( gpointer );
typedef void EffectHideUI ( gpointer );
typedef gdouble EffectApply ( gpointer, gdouble );
typedef void EffectReset ( gpointer );
typedef void EffectDestroy ( gpointer );

typedef struct st_effect
{
  gchar *name;
  gboolean active;
  gpointer data;

  EffectInit *init;
  EffectClone *clone;
  EffectMakeUI *make_ui;
  EffectShowUI *show_ui;
  EffectHideUI *hide_ui;
  EffectApply *apply;
  EffectReset *reset;
  EffectDestroy *destroy;

} Effect ;

extern Effect EffectRingMod;
extern Effect EffectFlanger;
extern Effect EffectCompressor;

/*
 * Destruction of an effect
 */
void
effect_destroy ( Effect * );


#endif
