/*
 * Effects Library
 */

#ifndef __EFFECTS_LIBRARY_H__
#define __EFFECTS_LIBRARY_H__

#include <glib.h>
#include "effect.h"

typedef struct st_effects_library
{
  GHashTable *table;

} EffectsLibrary ;


EffectsLibrary *
effects_library_new ( void );

void
effects_library_add ( EffectsLibrary *,
                      Effect * );

Effect *
effects_library_get_new ( EffectsLibrary *,
                          gchar * );

Effect *
effects_library_get ( EffectsLibrary *,
                      gchar * );

void
effects_library_foreach ( EffectsLibrary *,
                          GHFunc,
                          gpointer );

void
effects_library_remove ( EffectsLibrary *,
                         gchar * );

void
effects_library_destroy ( EffectsLibrary * );


#endif
