/*
 * Sound Output with ALSA
 */

#ifndef __SND_OUT_ALSA_H__
#define __SND_OUT_ALSA_H__

#include <glib.h>
#include <alsa/asoundlib.h>
#include "wave.h"

typedef struct st_snd_out_alsa
{
  snd_pcm_t *handle;
  snd_pcm_hw_params_t *params;
  snd_pcm_uframes_t snd_frames;
  guint snd_period_time;
  gint buf_size;
  gint16 *buffer;

  GThread *thread;
  gboolean play;
  Wave *wave;

} SndOutAlsa ;


extern guint SOUND_RATE;


/*
 * Constructors
 */
SndOutAlsa *
snd_out_alsa_new ( void );


/*
 * Playback a wave
 */
void
snd_out_alsa_play ( SndOutAlsa *,
                    Wave * );


/*
 * Is playing ?
 */
gboolean
snd_out_alsa_is_playing ( SndOutAlsa * );


/*
 * Stop playback
 */
void
snd_out_alsa_stop ( SndOutAlsa * );


/*
 * Destructor
 */
void
snd_out_alsa_destroy ( SndOutAlsa * );

#endif
