/*
 * WaveGenerator
 */

#ifndef __WAVE_GENERATOR_H__
#define __WAVE_GENERATOR_H__

#include <gtk/gtk.h>

typedef void WaveGeneratorInit ( gpointer );
typedef gpointer WaveGeneratorClone ( gpointer );
typedef void WaveGeneratorMakeUI ( gpointer, GtkBox * );
typedef void WaveGeneratorShowUI ( gpointer );
typedef void WaveGeneratorHideUI ( gpointer );
typedef gdouble WaveGeneratorIter ( gpointer );
typedef void WaveGeneratorReset ( gpointer );
typedef void WaveGeneratorDestroy ( gpointer );

typedef struct st_wave_generator
{
  gchar *name;
  gpointer data;

  WaveGeneratorInit *init;
  WaveGeneratorClone *clone;
  WaveGeneratorMakeUI *make_ui;
  WaveGeneratorShowUI *show_ui;
  WaveGeneratorHideUI *hide_ui;
  WaveGeneratorIter *iter;
  WaveGeneratorReset *reset;
  WaveGeneratorDestroy *destroy;

} WaveGenerator ;

extern WaveGenerator WaveGeneratorSine;
extern WaveGenerator WaveGeneratorSquare;
extern WaveGenerator WaveGeneratorTriangle;
extern WaveGenerator WaveGeneratorSaw;


/*
 * Destruction of a wave generator
 */
void
wave_generator_destroy ( WaveGenerator * );

#endif
