/*
 * Saw Wave Generator
 * Based on the simple wave generator
 */

#include <math.h>
#include "wave_generator.h"
#include "wave_generator_simple.h"

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

/*
 * Cloning operation.
 * Returns a brand new saw wave generator.
 */
gpointer
wave_generator_saw_clone ( gpointer data )
{
  return wave_generator_simple_clone_from_instance ( data, &WaveGeneratorSaw );
}


/*
 * Iterates the wave generator.
 * Returns the new value.
 */
gdouble
wave_generator_saw_iter ( gpointer data )
{
  gdouble ret;
  WaveGeneratorSimpleData *wgsd;

  if ( data == NULL )
    return 0.0;

  wgsd = (WaveGeneratorSimpleData *) data;

  ret = wgsd->x - ( floor(wgsd->x/( 2.0*M_PI )) * ( 2.0*M_PI ) );
  ret = (ret*(0.5/M_PI)) - 1.0;

  wgsd->x += wgsd->x_inc;

  return ret;
}


/*
 * Saw Wave Generator
 */
WaveGenerator WaveGeneratorSaw = 
  {
    "saw",
    NULL,
    wave_generator_simple_init,
    wave_generator_saw_clone,
    wave_generator_simple_make_ui,
    wave_generator_simple_show_ui,
    wave_generator_simple_hide_ui,
    wave_generator_saw_iter,
    wave_generator_simple_reset,
    wave_generator_simple_destroy
  } ;
