/*
 * Simple Wave Generator
 * Abstract wave generator which provides basic behaviour.
 */

#ifndef __WAVE_GENERATOR_SIMPLE_H__
#define __WAVE_GENERATOR_SIMPLE_H__

#include <gtk/gtk.h>


/*
 * Internal data structure
 */
typedef struct st_wg_simple_data
{
  gdouble freq;
  gdouble x;
  gdouble x_inc;

  GtkVBox *vbox;

} WaveGeneratorSimpleData ;


/*
 * Initilization of the simple wave generator.
 */
void
wave_generator_simple_init ( gpointer );


/*
 * Cloning operation.
 * Returns a brand new simple wave generator.
 */
gpointer
wave_generator_simple_clone ( gpointer );


/*
 * Generic cloning operation which clones from an instance.
 * Returns a brand new wave generator.
 */
gpointer
wave_generator_simple_clone_from_instance ( gpointer,
                                            gpointer );


/*
 * Makes the configuration user interface
 */
void
wave_generator_simple_make_ui ( gpointer,
                                GtkBox * );


/*
 * Show/Hide the UI of the wave generator
 */
void
wave_generator_simple_show_ui ( gpointer );

void
wave_generator_simple_hide_ui ( gpointer );


/*
 * Resets the wave generator.
 */
void
wave_generator_simple_reset ( gpointer );


/*
 * Destroys the wave generator.
 */
void
wave_generator_simple_destroy ( gpointer );


#endif
