/*
 * Sine Wave Generator
 * Based on the simple wave generator
 */

#include <math.h>
#include "wave_generator.h"
#include "wave_generator_simple.h"


/*
 * Cloning operation.
 * Returns a brand new sine wave generator.
 */
gpointer
wave_generator_sine_clone ( gpointer data )
{
  return wave_generator_simple_clone_from_instance ( data, &WaveGeneratorSine );
}


/*
 * Iterates the wave generator.
 * Returns the new value.
 */
gdouble
wave_generator_sine_iter ( gpointer data )
{
  gdouble ret;
  WaveGeneratorSimpleData *wgsd;

  if ( data == NULL )
    return 0.0;

  wgsd = (WaveGeneratorSimpleData *) data;

  ret = sin ( wgsd->x );
  wgsd->x += wgsd->x_inc;

  return ret;
}


/*
 * Sine Wave Generator
 */
WaveGenerator WaveGeneratorSine = 
  {
    "sine",
    NULL,
    wave_generator_simple_init,
    wave_generator_sine_clone,
    wave_generator_simple_make_ui,
    wave_generator_simple_show_ui,
    wave_generator_simple_hide_ui,
    wave_generator_sine_iter,
    wave_generator_simple_reset,
    wave_generator_simple_destroy
  } ;
