/*
 * Wave Generators Library
 */

#ifndef __WAVE_GENERATORS_LIBRARY_H__
#define __WAVE_GENERATORS_LIBRARY_H__

#include <glib.h>
#include "wave_generator.h"

typedef struct st_wave_generators_library
{
  GHashTable *table;

} WaveGeneratorsLibrary ;


WaveGeneratorsLibrary *
wave_generators_library_new ( void );

void
wave_generators_library_add ( WaveGeneratorsLibrary *,
                              WaveGenerator * );

WaveGenerator *
wave_generators_library_get_new ( WaveGeneratorsLibrary *,
                                  gchar * );

WaveGenerator *
wave_generators_library_get ( WaveGeneratorsLibrary *,
                              gchar * );

void
wave_generators_library_foreach ( WaveGeneratorsLibrary *,
                                  GHFunc,
                                  gpointer );

void
wave_generators_library_remove ( WaveGeneratorsLibrary *,
                                 gchar * );

void
wave_generators_library_destroy ( WaveGeneratorsLibrary * );


#endif
